# --- [ xbee_list.py ] ------------------------------------------------------------
#
# Bedient die beiden Register in Optionen.Einstellung
# und stellt in Optionen.Device_Liste die Stationen in einer Liste dar

import tkinter as Tk
from tkinter import ttk

import listbox
#import cl_check
import xbee_adr
#import inputs
#import frames

        
class Register3():
    def __init__(self, master, listvar, width = 40, height = 4):
        lb = listbox.My_Listbox(master, width = width, height = height, listvar = listvar)
        lb.grid(column = 0, row =0, padx = 5, pady =5, sticky = "nsew")
    


def xbee_list(parent):
    """ Zeigt ein Top-Level-Window mit einer Liste der Devices
        Die Liste ist maximal 14 Zeilen lang,
        es kann mit dem Cursor nach unten gescrollt werden.
        Eine Veränderung des Daten ist nicht vorgesehen
    """

    w = Tk.Toplevel()       # ein unabhängiges Toplevel-Window öffnen
    w.resizable(width = False, height = False) # Größe nicht veränderbar
    w.title("XBee-Device-Liste")
    w.geometry('+200+150')

#    xbee_adr.read_xbee_adr()

##    stationlist = list()
##    for i in range(len(xbee_adr.adr_64bit)):
##        zeile = ""
##
##        for j in range(8):
##            zeile += "{:>02X}".format(xbee_adr.adr_64bit[i][j])
##            zeile += " "
##
##        zeile += ("--- ")
##        for j in range(2):
##            zeile += "{:>02X}".format(xbee_adr.adr_16bit[i][j])       
##            zeile += " "
##        zeile += "--- "
##        zeile += "{:<20}".format(xbee_adr.adr_names[i])
##        zeile += xbee_adr.adr_states[i]
##       
##        stationlist.append(zeile)
##    
##    stationlist = tuple(stationlist)
    stationlist = tuple(xbee_adr.get_Station_List())
    height = len(stationlist)
    if height > 14:
        height = 14
    
    Register3(w, listvar = stationlist,
              width = 80, height = height)

    w.focus_set()           # focus auf das Fenster
    w.grab_set()            # alle Events werden nur nach w durchgereicht,
                            # das drunterliegende Fenster bleibt inaktiv, wird aber aktualisiert
    w.transient(parent)        # das Fenster bleibt oberhalb von Top
#   w.wait_window(w)        # warten bis zum Beenden des Fensters, aber ...
                            # ... die Zeit zählt dann nicht weiter
    w.mainloop()  



if __name__ == "__main__":

    top = Tk.Tk()
    frm = ttk.LabelFrame(top, text = "dsf slödfj aölsdfj")
    frm.grid(column = 0, row = 0)
    lbl = ttk.Label(frm, text = "dsaölfj asödfj ")
    lbl.grid(column = 0, row = 0) 
    
    xbee_list(parent = top)

    top.mainloop()
