# --- [ cl_check.py ] --------------------------------------------------------
#
# Hier werden CheckButtons mit IntVars in einer Klasse vereint.
import tkinter as Tk


class Chk_Button(Tk.Checkbutton):

    chk_button_list = []
    chk_button_onvalue = 1


    def read_all():
        r = 0
        for i in Chk_Button.chk_button_list:
            a = i.get()
            r += a
            print(a, r)
        

    """ Ein Checkbutton und eine IntVar werden zusammenstellt. """
    def __init__(self, master,
                 #onvalue = 1,
                 value = 1,
                 column = 0,
                 row = 0,
                 command = read_all,
                 anchor = "w",                
                  **kw):
        
        Tk.Checkbutton.__init__(self, master,
                             #onvalue = onvalue,
                             command = command,
                             anchor = anchor,
                             **kw)

        self.__variable = Tk.IntVar()
        self.__class__.chk_button_list.append(self.__variable)
        
        if value:
            self.__variable.set(self.__class__.chk_button_onvalue)
        else:
            self.__variable.set(0)
            
        self.configure(variable = self.__variable)
        self.configure(onvalue = self.__class__.chk_button_onvalue)
        self.__class__.chk_button_onvalue *= 2
         
        self.grid(column = column, row = row, padx = 5, pady = 3, sticky = "w")

    def get_Value(self):
        return self.__variable.get()

    def set_Value(self, value):
        if value:
            value = self.__onvalue
        self.__variable.set(value)



    
if __name__ == "__main__":

##    def read_all():
##        print(ck1.get_Value())
##        print(ck2.get_Value())
##        print(ck3.get_Value())
##        for i in self.__class__.chk_button_list:
##            print(i.get())

    top = Tk.Tk()
    top.title("Checkbutton-Test")

    frm1 = Tk.LabelFrame(top, text = "Checkbutton", width = 600, height = 20)
    frm1.grid(column = 0, row = 0, padx = 5, pady = 5, sticky = "nsew")


    ck1 = Chk_Button(frm1, text = "adsfsf", row = 0, value = 1)
    ck2 = Chk_Button(frm1, text = "ASSasf", row = 1, value = 0)
    ck3 = Chk_Button(frm1, text = "asAAsf", row = 2, value = 1)

    top.mainloop()

# --- [ eof ] --------------------------------------------------------------
